From 21832adf87d7e59b3942e0a9fc675d38fdf2a252 Mon Sep 17 00:00:00 2001
From: Thomas Lecavelier <thomas@lecavelier.name>
Date: Fri, 18 Dec 2009 12:27:02 +0100
Subject: [PATCH] Add option to force default language for non logged in users

---
 app/controllers/application_controller.rb |    2 +-
 app/views/settings/_display.rhtml         |    6 +++++-
 config/environments/development.rb        |    2 ++
 config/locales/bg.yml                     |    1 +
 config/locales/bs.yml                     |    1 +
 config/locales/ca.yml                     |    1 +
 config/locales/cs.yml                     |    1 +
 config/locales/da.yml                     |    1 +
 config/locales/de.yml                     |    1 +
 config/locales/el.yml                     |    1 +
 config/locales/en.yml                     |    1 +
 config/locales/es.yml                     |    1 +
 config/locales/fi.yml                     |    1 +
 config/locales/fr.yml                     |    1 +
 config/locales/gl.yml                     |    1 +
 config/locales/he.yml                     |    1 +
 config/locales/hu.yml                     |    1 +
 config/locales/it.yml                     |    1 +
 config/locales/ja.yml                     |    1 +
 config/locales/ko.yml                     |    1 +
 config/locales/lt.yml                     |    1 +
 config/locales/nl.yml                     |    1 +
 config/locales/no.yml                     |    1 +
 config/locales/pl.yml                     |    1 +
 config/locales/pt-BR.yml                  |    1 +
 config/locales/pt.yml                     |    1 +
 config/locales/ro.yml                     |    1 +
 config/locales/ru.yml                     |    1 +
 config/locales/sk.yml                     |    1 +
 config/locales/sl.yml                     |    1 +
 config/locales/sr.yml                     |    1 +
 config/locales/sv.yml                     |    1 +
 config/locales/th.yml                     |    1 +
 config/locales/tr.yml                     |    1 +
 config/locales/uk.yml                     |    1 +
 config/locales/vi.yml                     |    1 +
 config/locales/zh-TW.yml                  |    1 +
 config/locales/zh.yml                     |    1 +
 config/settings.yml                       |    2 ++
 39 files changed, 45 insertions(+), 2 deletions(-)

diff --git a/app/controllers/application_controller.rb b/app/controllers/application_controller.rb
index c694198..b76d33c 100644
--- a/app/controllers/application_controller.rb
+++ b/app/controllers/application_controller.rb
@@ -95,7 +95,7 @@ class ApplicationController < ActionController::Base
     if User.current.logged?
       lang = find_language(User.current.language)
     end
-    lang ||= Setting.default_language
+    lang ||= Setting.default_language if Setting.force_default_language?
     if lang.blank? && request.env['HTTP_ACCEPT_LANGUAGE']
       accept_lang = parse_qvalues(request.env['HTTP_ACCEPT_LANGUAGE']).first.downcase
       if !accept_lang.blank?
diff --git a/app/views/settings/_display.rhtml b/app/views/settings/_display.rhtml
index fc1c397..d1aba0b 100644
--- a/app/views/settings/_display.rhtml
+++ b/app/views/settings/_display.rhtml
@@ -4,8 +4,12 @@
 <p><label><%= l(:label_theme) %></label>
 <%= select_tag 'settings[ui_theme]', options_for_select( ([[l(:label_default), '']] + Redmine::Themes.themes.collect {|t| [t.name, t.id]}), Setting.ui_theme) %></p>
 
+<p><label><%= l(:setting_force_default_language) %></label>
+<%= hidden_field_tag 'settings[force_default_language]', 0 %>
+<%= check_box_tag 'settings[force_default_language]', 1, Setting.force_default_language? %></p>
+
 <p><label><%= l(:setting_default_language) %></label>
-<%= select_tag 'settings[default_language]', options_for_select( lang_options_for_select(true), Setting.default_language) %></p>
+<%= select_tag 'settings[default_language]', options_for_select( lang_options_for_select(false), Setting.default_language) %></p>
 
 <p><label><%= l(:setting_start_of_week) %></label>
 <%= select_tag 'settings[start_of_week]', options_for_select( [[l(:label_language_based), ''], [day_name(1),'1'], [day_name(7),'7']] , Setting.start_of_week) %></p>
diff --git a/config/environments/development.rb b/config/environments/development.rb
index c816f03..a789aeb 100644
--- a/config/environments/development.rb
+++ b/config/environments/development.rb
@@ -14,3 +14,5 @@ config.action_controller.perform_caching             = false
 
 # Don't care if the mailer can't send
 config.action_mailer.raise_delivery_errors = false
+
+config.action_controller.session = { :key => "_myapp_session", :secret => "06b97e42aa64752d82888def81bb7ae5f0b849c5c034f173fd9c44b4b190d29ea0d34c92b668aa445247d96acabcdfd3cd6573b80a17405266d8959dd95a9174" }
diff --git a/config/locales/bg.yml b/config/locales/bg.yml
index 300bd38..b8c6c89 100644
--- a/config/locales/bg.yml
+++ b/config/locales/bg.yml
@@ -236,6 +236,7 @@ bg:
   setting_app_title: Заглавие
   setting_app_subtitle: Описание
   setting_welcome_text: Допълнителен текст
+  setting_force_default_language: Force default language
   setting_default_language: Език по подразбиране
   setting_login_required: Изискване за вход в системата
   setting_self_registration: Регистрация от потребители
diff --git a/config/locales/bs.yml b/config/locales/bs.yml
index d2bd180..fa18a5d 100644
--- a/config/locales/bs.yml
+++ b/config/locales/bs.yml
@@ -279,6 +279,7 @@ bs:
   setting_app_title: Naslov aplikacije
   setting_app_subtitle: Podnaslov aplikacije
   setting_welcome_text: Tekst dobrodošlice
+  setting_force_default_language: Force default language
   setting_default_language: Podrazumjevani jezik
   setting_login_required: Authentifikacija neophodna
   setting_self_registration: Samo-registracija
diff --git a/config/locales/ca.yml b/config/locales/ca.yml
index 0019a5f..bf8f188 100644
--- a/config/locales/ca.yml
+++ b/config/locales/ca.yml
@@ -261,6 +261,7 @@ ca:
   setting_app_title: "Títol de l'aplicació"
   setting_app_subtitle: "Subtítol de l'aplicació"
   setting_welcome_text: Text de benvinguda
+  setting_force_default_language: Force default language
   setting_default_language: Idioma predeterminat
   setting_login_required: Es necessita autenticació
   setting_self_registration: Registre automàtic
diff --git a/config/locales/cs.yml b/config/locales/cs.yml
index 03d6d90..b470c09 100644
--- a/config/locales/cs.yml
+++ b/config/locales/cs.yml
@@ -255,6 +255,7 @@ cs:
   setting_app_title: Název aplikace
   setting_app_subtitle: Podtitulek aplikace
   setting_welcome_text: Uvítací text
+  setting_force_default_language: Force default language
   setting_default_language: Výchozí jazyk
   setting_login_required: Auten. vyžadována
   setting_self_registration: Povolena automatická registrace
diff --git a/config/locales/da.yml b/config/locales/da.yml
index c627f73..32a14f5 100644
--- a/config/locales/da.yml
+++ b/config/locales/da.yml
@@ -271,6 +271,7 @@ da:
   setting_app_title: Applikationstitel
   setting_app_subtitle: Applikationsundertekst
   setting_welcome_text: Velkomsttekst
+  setting_force_default_language: Force default language
   setting_default_language: Standardsporg
   setting_login_required: Sikkerhed påkrævet
   setting_self_registration: Brugeroprettelse
diff --git a/config/locales/de.yml b/config/locales/de.yml
index e936faf..c778032 100644
--- a/config/locales/de.yml
+++ b/config/locales/de.yml
@@ -280,6 +280,7 @@ de:
   setting_app_title: Applikations-Titel
   setting_app_subtitle: Applikations-Untertitel
   setting_welcome_text: Willkommenstext
+  setting_force_default_language: Force default language
   setting_default_language: Default-Sprache
   setting_login_required: Authentisierung erforderlich
   setting_self_registration: Anmeldung ermöglicht
diff --git a/config/locales/el.yml b/config/locales/el.yml
index 76825d8..ffe6af5 100644
--- a/config/locales/el.yml
+++ b/config/locales/el.yml
@@ -271,6 +271,7 @@ el:
   setting_app_title: Τίτλος εφαρμογής
   setting_app_subtitle: Υπότιτλος εφαρμογής
   setting_welcome_text: Κείμενο υποδοχής
+  setting_force_default_language: Force default language
   setting_default_language: Προεπιλεγμένη γλώσσα
   setting_login_required: Απαιτείται πιστοποίηση
   setting_self_registration: Αυτο-εγγραφή
diff --git a/config/locales/en.yml b/config/locales/en.yml
index 1be78eb..06fd9ec 100644
--- a/config/locales/en.yml
+++ b/config/locales/en.yml
@@ -276,6 +276,7 @@ en:
   setting_app_title: Application title
   setting_app_subtitle: Application subtitle
   setting_welcome_text: Welcome text
+  setting_force_default_language: Force default language
   setting_default_language: Default language
   setting_login_required: Authentication required
   setting_self_registration: Self-registration
diff --git a/config/locales/es.yml b/config/locales/es.yml
index 7a22b73..3308743 100644
--- a/config/locales/es.yml
+++ b/config/locales/es.yml
@@ -750,6 +750,7 @@ es:
   setting_commit_ref_keywords: Palabras clave para la referencia
   setting_cross_project_issue_relations: Permitir relacionar peticiones de distintos proyectos
   setting_date_format: Formato de fecha
+  setting_force_default_language: Force default language
   setting_default_language: Idioma por defecto
   setting_default_projects_public: Los proyectos nuevos son públicos por defecto
   setting_diff_max_lines_displayed: Número máximo de diferencias mostradas
diff --git a/config/locales/fi.yml b/config/locales/fi.yml
index 7b2e754..eda902f 100644
--- a/config/locales/fi.yml
+++ b/config/locales/fi.yml
@@ -284,6 +284,7 @@ fi:
   setting_app_title: Ohjelman otsikko
   setting_app_subtitle: Ohjelman alaotsikko
   setting_welcome_text: Tervehdysteksti
+  setting_force_default_language: Force default language
   setting_default_language: Vakiokieli
   setting_login_required: Pakollinen kirjautuminen
   setting_self_registration: Itserekisteröinti
diff --git a/config/locales/fr.yml b/config/locales/fr.yml
index fd32c6b..23ed122 100644
--- a/config/locales/fr.yml
+++ b/config/locales/fr.yml
@@ -298,6 +298,7 @@ fr:
   setting_app_title: Titre de l'application
   setting_app_subtitle: Sous-titre de l'application
   setting_welcome_text: Texte d'accueil
+  setting_force_default_language: Forcer la langue par défaut
   setting_default_language: Langue par défaut
   setting_login_required: Authentification obligatoire
   setting_self_registration: Inscription des nouveaux utilisateurs
diff --git a/config/locales/gl.yml b/config/locales/gl.yml
index 77698bd..2cbacda 100644
--- a/config/locales/gl.yml
+++ b/config/locales/gl.yml
@@ -729,6 +729,7 @@ gl:
   setting_commit_ref_keywords: Palabras clave para a referencia
   setting_cross_project_issue_relations: Permitir relacionar peticións de distintos proxectos
   setting_date_format: Formato da data
+  setting_force_default_language: Force default language
   setting_default_language: Idioma por defecto
   setting_default_projects_public: Os proxectos novos son públicos por defecto
   setting_diff_max_lines_displayed: Número máximo de diferencias mostradas
diff --git a/config/locales/he.yml b/config/locales/he.yml
index b7df4fb..75dd85d 100644
--- a/config/locales/he.yml
+++ b/config/locales/he.yml
@@ -249,6 +249,7 @@ he:
   setting_app_title: כותרת ישום
   setting_app_subtitle: תת-כותרת ישום
   setting_welcome_text: טקסט "ברוך הבא"
+  setting_force_default_language: Force default language
   setting_default_language: שפת ברירת מחדל
   setting_login_required: דרוש אימות
   setting_self_registration: אפשר הרשמות עצמית
diff --git a/config/locales/hu.yml b/config/locales/hu.yml
index 71023e7..c1423a5 100644
--- a/config/locales/hu.yml
+++ b/config/locales/hu.yml
@@ -281,6 +281,7 @@
   setting_app_title: Alkalmazás címe
   setting_app_subtitle: Alkalmazás alcíme
   setting_welcome_text: Üdvözlő üzenet
+  setting_force_default_language: Force default language
   setting_default_language: Alapértelmezett nyelv
   setting_login_required: Azonosítás szükséges
   setting_self_registration: Regisztráció
diff --git a/config/locales/it.yml b/config/locales/it.yml
index 6ec67fe..5a22bd1 100644
--- a/config/locales/it.yml
+++ b/config/locales/it.yml
@@ -249,6 +249,7 @@ it:
   setting_app_title: Titolo applicazione
   setting_app_subtitle: Sottotitolo applicazione
   setting_welcome_text: Testo di benvenuto
+  setting_force_default_language: Force default language
   setting_default_language: Lingua predefinita
   setting_login_required: Autenticazione richiesta
   setting_self_registration: Auto-registrazione abilitata
diff --git a/config/locales/ja.yml b/config/locales/ja.yml
index 24127d8..ab638b9 100644
--- a/config/locales/ja.yml
+++ b/config/locales/ja.yml
@@ -300,6 +300,7 @@ ja:
   setting_app_title: アプリケーションのタイトル
   setting_app_subtitle: アプリケーションのサブタイトル
   setting_welcome_text: ウェルカムメッセージ
+  setting_force_default_language: Force default language
   setting_default_language: 既定の言語
   setting_login_required: 認証が必要
   setting_self_registration: ユーザは自分で登録できる
diff --git a/config/locales/ko.yml b/config/locales/ko.yml
index 5402fc1..4eabb3f 100644
--- a/config/locales/ko.yml
+++ b/config/locales/ko.yml
@@ -327,6 +327,7 @@ ko:
   setting_app_title: 레드마인 제목
   setting_app_subtitle: 레드마인 부제목
   setting_welcome_text: 환영 메시지
+  setting_force_default_language: Force default language
   setting_default_language: 기본 언어
   setting_login_required: 인증이 필요함
   setting_self_registration: 사용자 직접등록
diff --git a/config/locales/lt.yml b/config/locales/lt.yml
index b7d6eec..c3ef199 100644
--- a/config/locales/lt.yml
+++ b/config/locales/lt.yml
@@ -340,6 +340,7 @@ lt:
   setting_app_title: Programos pavadinimas
   setting_app_subtitle: Programos paantraštė
   setting_welcome_text: Pasveikinimas
+  setting_force_default_language: Force default language
   setting_default_language: Numatytoji kalba
   setting_login_required: Reikalingas autentiškumo nustatymas
   setting_self_registration: Saviregistracija
diff --git a/config/locales/nl.yml b/config/locales/nl.yml
index 2b50fd8..72f65a9 100644
--- a/config/locales/nl.yml
+++ b/config/locales/nl.yml
@@ -691,6 +691,7 @@ nl:
   setting_commit_ref_keywords: Refererende trefwoorden
   setting_cross_project_issue_relations: Sta crossproject issuerelaties toe
   setting_date_format: Datumformaat
+  setting_force_default_language: Force default language
   setting_default_language: Standaard taal
   setting_default_projects_public: Nieuwe projecten zijn standaard publiek
   setting_diff_max_lines_displayed: Max number of diff lines displayed
diff --git a/config/locales/no.yml b/config/locales/no.yml
index 6eda0fa..cc7dca3 100644
--- a/config/locales/no.yml
+++ b/config/locales/no.yml
@@ -253,6 +253,7 @@
   setting_app_title: Applikasjonstittel
   setting_app_subtitle: Applikasjonens undertittel
   setting_welcome_text: Velkomsttekst
+  setting_force_default_language: Force default language
   setting_default_language: Standardspråk
   setting_login_required: Krever innlogging
   setting_self_registration: Selvregistrering
diff --git a/config/locales/pl.yml b/config/locales/pl.yml
index 1eb0c0e..3bb6fc5 100644
--- a/config/locales/pl.yml
+++ b/config/locales/pl.yml
@@ -729,6 +729,7 @@ pl:
   setting_commit_ref_keywords: Słowa tworzące powiązania
   setting_cross_project_issue_relations: Zezwól na powiązania zagadnień między projektami
   setting_date_format: Format daty
+  setting_force_default_language: Force default language
   setting_default_language: Domyślny język
   setting_default_projects_public: Nowe projekty są domyślnie publiczne
   setting_display_subprojects_issues: Domyślnie pokazuj zagadnienia podprojektów w głównym projekcie
diff --git a/config/locales/pt-BR.yml b/config/locales/pt-BR.yml
index 98fcf1d..b47e991 100644
--- a/config/locales/pt-BR.yml
+++ b/config/locales/pt-BR.yml
@@ -287,6 +287,7 @@ pt-BR:
   setting_app_title: Título da aplicação
   setting_app_subtitle: Sub-título da aplicação
   setting_welcome_text: Texto de boas-vindas
+  setting_force_default_language: Force default language
   setting_default_language: Idioma padrão
   setting_login_required: Exigir autenticação
   setting_self_registration: Permitido Auto-registro
diff --git a/config/locales/pt.yml b/config/locales/pt.yml
index 2a61405..7ebb5a9 100644
--- a/config/locales/pt.yml
+++ b/config/locales/pt.yml
@@ -272,6 +272,7 @@ pt:
   setting_app_title: Título da aplicação
   setting_app_subtitle: Sub-título da aplicação
   setting_welcome_text: Texto de boas vindas
+  setting_force_default_language: Force default language
   setting_default_language: Língua por omissão
   setting_login_required: Autenticação obrigatória
   setting_self_registration: Auto-registo
diff --git a/config/locales/ro.yml b/config/locales/ro.yml
index 4f098e8..7c61a49 100644
--- a/config/locales/ro.yml
+++ b/config/locales/ro.yml
@@ -259,6 +259,7 @@ ro:
   setting_app_title: Titlu aplicație
   setting_app_subtitle: Subtitlu aplicație
   setting_welcome_text: Text de întâmpinare
+  setting_force_default_language: Force default language
   setting_default_language: Limba implicita
   setting_login_required: Necesita autentificare
   setting_self_registration: Înregistrare automată
diff --git a/config/locales/ru.yml b/config/locales/ru.yml
index 0814137..e80c5ed 100644
--- a/config/locales/ru.yml
+++ b/config/locales/ru.yml
@@ -827,6 +827,7 @@ ru:
   setting_commit_ref_keywords: Ключевые слова для поиска
   setting_cross_project_issue_relations: Разрешить пересечение задач по проектам
   setting_date_format: Формат даты
+  setting_force_default_language: Force default language
   setting_default_language: Язык по умолчанию
   setting_default_projects_public: Новые проекты являются общедоступными
   setting_diff_max_lines_displayed: Максимальное число строк для diff
diff --git a/config/locales/sk.yml b/config/locales/sk.yml
index 5798a48..3a41847 100644
--- a/config/locales/sk.yml
+++ b/config/locales/sk.yml
@@ -253,6 +253,7 @@ sk:
   setting_app_title: Názov aplikácie
   setting_app_subtitle: Podtitulok aplikácie
   setting_welcome_text: Uvítací text
+  setting_force_default_language: Force default language
   setting_default_language: Východzí jazyk
   setting_login_required: Auten. vyžadovaná
   setting_self_registration: Povolenie registrácie
diff --git a/config/locales/sl.yml b/config/locales/sl.yml
index 30c2e37..7e63d65 100644
--- a/config/locales/sl.yml
+++ b/config/locales/sl.yml
@@ -255,6 +255,7 @@ sl:
   setting_app_title: Naslov aplikacije
   setting_app_subtitle: Podnaslov aplikacije
   setting_welcome_text: Pozdravno besedilo
+  setting_force_default_language: Force default language
   setting_default_language: Privzeti jezik
   setting_login_required: Zahtevano overovljanje
   setting_self_registration: Samostojna registracija
diff --git a/config/locales/sr.yml b/config/locales/sr.yml
index f7af3d4..23b566a 100644
--- a/config/locales/sr.yml
+++ b/config/locales/sr.yml
@@ -261,6 +261,7 @@
   setting_app_title: Naziv aplikacije
   setting_app_subtitle: Podnaslov aplikacije
   setting_welcome_text: Tekst dobrodošlice
+  setting_force_default_language: Force default language
   setting_default_language: Podrazumevani jezik
   setting_login_required: Prijavljivanje je obavezno
   setting_self_registration: Samoregistracija je dozvoljena
diff --git a/config/locales/sv.yml b/config/locales/sv.yml
index 7a18800..070d758 100644
--- a/config/locales/sv.yml
+++ b/config/locales/sv.yml
@@ -320,6 +320,7 @@ sv:
   setting_app_title: Applikationsrubrik
   setting_app_subtitle: Applikationsunderrubrik
   setting_welcome_text: Välkomsttext
+  setting_force_default_language: Force default language
   setting_default_language: Standardspråk
   setting_login_required: Kräver inloggning
   setting_self_registration: Självregistrering
diff --git a/config/locales/th.yml b/config/locales/th.yml
index 1e88942..ad3f610 100644
--- a/config/locales/th.yml
+++ b/config/locales/th.yml
@@ -251,6 +251,7 @@ th:
   setting_app_title: ชื่อโปรแกรม
   setting_app_subtitle: ชื่อโปรแกรมรอง
   setting_welcome_text: ข้อความต้อนรับ
+  setting_force_default_language: Force default language
   setting_default_language: ภาษาเริ่มต้น
   setting_login_required: ต้องป้อนผู้ใช้-รหัสผ่าน
   setting_self_registration: ลงทะเบียนด้วยตนเอง
diff --git a/config/locales/tr.yml b/config/locales/tr.yml
index 1135fc3..67b4835 100644
--- a/config/locales/tr.yml
+++ b/config/locales/tr.yml
@@ -282,6 +282,7 @@ tr:
   setting_app_title: Uygulama Bağlığı
   setting_app_subtitle: Uygulama alt başlığı
   setting_welcome_text: Hoşgeldin Mesajı
+  setting_force_default_language: Force default language
   setting_default_language: Varsayılan Dil
   setting_login_required: Kimlik denetimi gerekli mi
   setting_self_registration: Otomatik kayıt
diff --git a/config/locales/uk.yml b/config/locales/uk.yml
index f6288f6..f513d10 100644
--- a/config/locales/uk.yml
+++ b/config/locales/uk.yml
@@ -243,6 +243,7 @@ uk:
   setting_app_title: Назва додатку
   setting_app_subtitle: Підзаголовок додатку
   setting_welcome_text: Текст привітання
+  setting_force_default_language: Force default language
   setting_default_language: Стандартна мова
   setting_login_required: Необхідна аутентифікація
   setting_self_registration: Можлива само-реєстрація
diff --git a/config/locales/vi.yml b/config/locales/vi.yml
index 76e28e8..1d8343f 100644
--- a/config/locales/vi.yml
+++ b/config/locales/vi.yml
@@ -317,6 +317,7 @@ vi:
   setting_app_title: Tựa đề ứng dụng
   setting_app_subtitle: Tựa đề nhỏ của ứng dụng
   setting_welcome_text: Thông điệp chào mừng
+  setting_force_default_language: Force default language
   setting_default_language: Ngôn ngữ mặc định
   setting_login_required: Cần đăng nhập
   setting_self_registration: Tự chứng thực
diff --git a/config/locales/zh-TW.yml b/config/locales/zh-TW.yml
index f026719..80908fe 100644
--- a/config/locales/zh-TW.yml
+++ b/config/locales/zh-TW.yml
@@ -364,6 +364,7 @@
   setting_app_title: 標題
   setting_app_subtitle: 副標題
   setting_welcome_text: 歡迎詞
+  setting_force_default_language: Force default language
   setting_default_language: 預設語系
   setting_login_required: 需要驗證
   setting_self_registration: 註冊選項
diff --git a/config/locales/zh.yml b/config/locales/zh.yml
index 389ec4a..8001a0c 100644
--- a/config/locales/zh.yml
+++ b/config/locales/zh.yml
@@ -294,6 +294,7 @@ zh:
   setting_app_title: 应用程序标题
   setting_app_subtitle: 应用程序子标题
   setting_welcome_text: 欢迎文字
+  setting_force_default_language: Force default language
   setting_default_language: 默认语言
   setting_login_required: 要求认证
   setting_self_registration: 允许自注册
diff --git a/config/settings.yml b/config/settings.yml
index 1cbcba5..dae7ea9 100644
--- a/config/settings.yml
+++ b/config/settings.yml
@@ -55,6 +55,8 @@ text_formatting:
   default: textile
 wiki_compression:
   default: ""
+force_default_language:
+  default: 0
 default_language:
   default: en
 host_name:
-- 
1.6.3.3