Index: en.yml
===================================================================
--- en.yml	(revision 1)
+++ en.yml	(working copy)
@@ -73,8 +73,8 @@
 notice_email_sent: An email was sent to %s
 notice_email_error: An error occurred while sending mail (%s)
 notice_feeds_access_key_reseted: Your RSS access key was reset.
-notice_failed_to_save_issues: "Failed to save %d issue(s) on %d selected: %s."
-notice_no_issue_selected: "No issue is selected! Please, check the issues you want to edit."
+notice_failed_to_save_issues: "Failed to save %d task(s) on %d selected: %s."
+notice_no_issue_selected: "No task is selected! Please, check the tasks you want to edit."
 notice_account_pending: "Your account was created and is now pending administrator approval."
 notice_default_data_loaded: Default configuration successfully loaded.
 notice_unable_delete_version: Unable to delete version.
@@ -83,7 +83,7 @@
 error_scm_not_found: "The entry or revision was not found in the repository."
 error_scm_command_failed: "An error occurred when trying to access the repository: %s"
 error_scm_annotate: "The entry does not exist or can not be annotated."
-error_issue_not_found_in_project: 'The issue was not found or does not belong to this project'
+error_issue_not_found_in_project: 'The task was not found or does not belong to this project'
 
 warning_attachments_not_saved: "%d file(s) could not be saved."
 
@@ -95,8 +95,8 @@
 mail_body_account_information: Your account information
 mail_subject_account_activation_request: %s account activation request
 mail_body_account_activation_request: 'A new user (%s) has registered. The account is pending your approval:'
-mail_subject_reminder: "%d issue(s) due in the next days"
-mail_body_reminder: "%d issue(s) that are assigned to you are due in the next %d days:"
+mail_subject_reminder: "%d task(s) due in the next days"
+mail_body_reminder: "%d task(s) that are assigned to you are due in the next %d days:"
 
 gui_validation_error: 1 error
 gui_validation_error_plural: %d errors
@@ -124,10 +124,10 @@
 field_category: Category
 field_title: Title
 field_project: Project
-field_issue: Issue
+field_issue: Task
 field_status: Status
 field_notes: Notes
-field_is_closed: Issue closed
+field_is_closed: Task closed
 field_is_default: Default value
 field_tracker: Tracker
 field_subject: Subject
@@ -140,8 +140,8 @@
 field_homepage: Homepage
 field_is_public: Public
 field_parent: Subproject of
-field_is_in_chlog: Issues displayed in changelog
-field_is_in_roadmap: Issues displayed in roadmap
+field_is_in_chlog: Tasks displayed in changelog
+field_is_in_roadmap: Tasks displayed in roadmap
 field_login: Login
 field_mail_notification: Email notifications
 field_admin: Administrator
@@ -175,9 +175,9 @@
 field_spent_on: Date
 field_identifier: Identifier
 field_is_filter: Used as a filter
-field_issue_to_id: Related issue
+field_issue_to_id: Related task
 field_delay: Delay
-field_assignable: Issues can be assigned to this role
+field_assignable: Tasks can be assigned to this role
 field_redirect_existing_links: Redirect existing links
 field_estimated_hours: Estimated time
 field_column_names: Columns
@@ -194,7 +194,7 @@
 setting_login_required: Authentication required
 setting_self_registration: Self-registration
 setting_attachment_max_size: Attachment max. size
-setting_issues_export_limit: Issues export limit
+setting_issues_export_limit: Tasks export limit
 setting_mail_from: Emission email address
 setting_bcc_recipients: Blind carbon copy recipients (bcc)
 setting_plain_text_mail: plain text mail (no HTML)
@@ -210,8 +210,8 @@
 setting_autologin: Autologin
 setting_date_format: Date format
 setting_time_format: Time format
-setting_cross_project_issue_relations: Allow cross-project issue relations
-setting_issue_list_default_columns: Default columns displayed on the issue list
+setting_cross_project_issue_relations: Allow cross-project task relations
+setting_issue_list_default_columns: Default columns displayed on the task list
 setting_repositories_encodings: Repositories encodings
 setting_commit_logs_encoding: Commit messages encoding
 setting_emails_footer: Emails footer
@@ -219,7 +219,7 @@
 setting_per_page_options: Objects per page options
 setting_user_format: Users display format
 setting_activity_days_default: Days displayed on project activity
-setting_display_subprojects_issues: Display subprojects issues on main projects by default
+setting_display_subprojects_issues: Display subprojects tasks on main projects by default
 setting_enabled_scm: Enabled SCM
 setting_mail_handler_api_enabled: Enable WS for incoming emails
 setting_mail_handler_api_key: API key
@@ -231,15 +231,15 @@
 permission_select_project_modules: Select project modules
 permission_manage_members: Manage members
 permission_manage_versions: Manage versions
-permission_manage_categories: Manage issue categories
-permission_add_issues: Add issues
-permission_edit_issues: Edit issues
-permission_manage_issue_relations: Manage issue relations
+permission_manage_categories: Manage task categories
+permission_add_issues: Add tasks
+permission_edit_issues: Edit tasks
+permission_manage_issue_relations: Manage task relations
 permission_add_issue_notes: Add notes
 permission_edit_issue_notes: Edit notes
 permission_edit_own_issue_notes: Edit own notes
-permission_move_issues: Move issues
-permission_delete_issues: Delete issues
+permission_move_issues: Move tasks
+permission_delete_issues: Delete tasks
 permission_manage_public_queries: Manage public queries
 permission_save_queries: Save queries
 permission_view_gantt: View gantt chart
@@ -276,7 +276,7 @@
 permission_delete_messages: Delete messages
 permission_delete_own_messages: Delete own messages
 
-project_module_issue_tracking: Issue tracking
+project_module_issue_tracking: Task tracking
 project_module_time_tracking: Time tracking
 project_module_news: News
 project_module_documents: Documents
@@ -293,13 +293,13 @@
 label_project_plural: Projects
 label_project_all: All Projects
 label_project_latest: Latest projects
-label_issue: Issue
-label_issue_new: New issue
-label_issue_plural: Issues
-label_issue_view_all: View all issues
-label_issues_by: Issues by %s
-label_issue_added: Issue added
-label_issue_updated: Issue updated
+label_issue: Task
+label_issue_new: New task
+label_issue_plural: Tasks
+label_issue_view_all: View all tasks
+label_issues_by: Tasks by %s
+label_issue_added: Task added
+label_issue_updated: Task updated
 label_document: Document
 label_document_new: New document
 label_document_plural: Documents
@@ -315,11 +315,11 @@
 label_tracker_plural: Trackers
 label_tracker_new: New tracker
 label_workflow: Workflow
-label_issue_status: Issue status
-label_issue_status_plural: Issue statuses
+label_issue_status: Task status
+label_issue_status_plural: Task statuses
 label_issue_status_new: New status
-label_issue_category: Issue category
-label_issue_category_plural: Issue categories
+label_issue_category: Task category
+label_issue_category_plural: Task categories
 label_issue_category_new: New category
 label_custom_field: Custom field
 label_custom_field_plural: Custom fields
@@ -339,8 +339,8 @@
 label_login: Sign in
 label_logout: Sign out
 label_help: Help
-label_reported_issues: Reported issues
-label_assigned_to_me_issues: Issues assigned to me
+label_reported_issues: Reported tasks
+label_assigned_to_me_issues: Tasks assigned to me
 label_last_login: Last connection
 label_last_updates: Last updated
 label_last_updates_plural: %d last updated
@@ -475,7 +475,7 @@
 label_roadmap: Roadmap
 label_roadmap_due_in: Due in %s
 label_roadmap_overdue: %s late
-label_roadmap_no_issues: No issues for this version
+label_roadmap_no_issues: No tasks for this version
 label_search: Search
 label_result_plural: Results
 label_all_words: All words
@@ -490,7 +490,7 @@
 label_preview: Preview
 label_feed_plural: Feeds
 label_changes_details: Details of all changes
-label_issue_tracking: Issue tracking
+label_issue_tracking: Task tracking
 label_spent_time: Spent time
 label_f_hour: %.2f hour
 label_f_hour_plural: %.2f hours
@@ -505,8 +505,8 @@
 label_options: Options
 label_copy_workflow_from: Copy workflow from
 label_permissions_report: Permissions report
-label_watched_issues: Watched issues
-label_related_issues: Related issues
+label_watched_issues: Watched tasks
+label_related_issues: Related tasks
 label_applied_status: Applied status
 label_loading: Loading...
 label_relation_new: New relation
@@ -554,7 +554,7 @@
 label_changeset_plural: Changesets
 label_default_columns: Default columns
 label_no_change_option: (No change)
-label_bulk_edit_selected_issues: Bulk edit selected issues
+label_bulk_edit_selected_issues: Bulk edit selected tasks
 label_theme: Theme
 label_default: Default
 label_search_titles_only: Search titles only
@@ -649,27 +649,27 @@
 text_tracker_no_workflow: No workflow defined for this tracker
 text_unallowed_characters: Unallowed characters
 text_comma_separated: Multiple values allowed (comma separated).
-text_issues_ref_in_commit_messages: Referencing and fixing issues in commit messages
-text_issue_added: Issue %s has been reported by %s.
-text_issue_updated: Issue %s has been updated by %s.
+text_issues_ref_in_commit_messages: Referencing and fixing tasks in commit messages
+text_issue_added: Task %s has been reported by %s.
+text_issue_updated: Task %s has been updated by %s.
 text_wiki_destroy_confirmation: Are you sure you want to delete this wiki and all its content ?
-text_issue_category_destroy_question: Some issues (%d) are assigned to this category. What do you want to do ?
+text_issue_category_destroy_question: Some tasks (%d) are assigned to this category. What do you want to do ?
 text_issue_category_destroy_assignments: Remove category assignments
-text_issue_category_reassign_to: Reassign issues to this category
-text_user_mail_option: "For unselected projects, you will only receive notifications about things you watch or you're involved in (eg. issues you're the author or assignee)."
-text_no_configuration_data: "Roles, trackers, issue statuses and workflow have not been configured yet.\nIt is highly recommended to load the default configuration. You will be able to modify it once loaded."
+text_issue_category_reassign_to: Reassign tasks to this category
+text_user_mail_option: "For unselected projects, you will only receive notifications about things you watch or you're involved in (eg. tasks you're the author or assignee)."
+text_no_configuration_data: "Roles, trackers, task statuses and workflow have not been configured yet.\nIt is highly recommended to load the default configuration. You will be able to modify it once loaded."
 text_load_default_configuration: Load the default configuration
 text_status_changed_by_changeset: Applied in changeset %s.
-text_issues_destroy_confirmation: 'Are you sure you want to delete the selected issue(s) ?'
+text_issues_destroy_confirmation: 'Are you sure you want to delete the selected task(s) ?'
 text_select_project_modules: 'Select modules to enable for this project:'
 text_default_administrator_account_changed: Default administrator account changed
 text_file_repository_writable: Attachments directory writable
 text_plugin_assets_writable: Plugin assets directory writable
 text_rmagick_available: RMagick available (optional)
-text_destroy_time_entries_question: %.02f hours were reported on the issues you are about to delete. What do you want to do ?
+text_destroy_time_entries_question: %.02f hours were reported on the tasks you are about to delete. What do you want to do ?
 text_destroy_time_entries: Delete reported hours
 text_assign_time_entries_to_project: Assign reported hours to the project
-text_reassign_time_entries: 'Reassign reported hours to this issue:'
+text_reassign_time_entries: 'Reassign reported hours to this task:'
 text_user_wrote: '%s wrote:'
 text_enumeration_destroy_question: '%d objects are assigned to this value.'
 text_enumeration_category_reassign_to: 'Reassign them to this value:'
@@ -699,6 +699,6 @@
 default_activity_design: Design
 default_activity_development: Development
 
-enumeration_issue_priorities: Issue priorities
+enumeration_issue_priorities: Task priorities
 enumeration_doc_categories: Document categories
 enumeration_activities: Activities (time tracking)